--
-- HoseSystemFillArmVehicle
--
-- Authors: Wopster
-- Description: Enables you to let fillArm vehicles pump from your vehicle based on fillvolume
--
-- Copyright (c) Wopster, 2018

HoseSystemFillArmVehicle = {}

---
-- @param specializations
--
function HoseSystemFillArmVehicle.prerequisitesPresent(specializations)
    if not SpecializationUtil.hasSpecialization(Fillable, specializations) or not SpecializationUtil.hasSpecialization(FillVolume, specializations) then
        print("Warning - Specialization HoseSystemFillArmVehicle needs the specializations Fillable and FillVolume.")
        return false
    end

    return true
end

function HoseSystemFillArmVehicle:preLoad(savegame)
    self.checkPlaneY = HoseSystemFillArmVehicle.checkPlaneY
end

function HoseSystemFillArmVehicle:load(savegame)
    self.fillArmFillVolumeIndex = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.hoseSystemFillArmVehicle#fillVolumeIndex"), 1)
    self.fillArmOffset = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.hoseSystemFillArmVehicle#fillArmOffset"), 0)
    self.supportsHoseSystem = self.fillArmFillVolumeIndex ~= nil
end

function HoseSystemFillArmVehicle:delete()
end

function HoseSystemFillArmVehicle:mouseEvent(...)
end

function HoseSystemFillArmVehicle:keyEvent(...)
end

function HoseSystemFillArmVehicle:update(dt)
end

function HoseSystemFillArmVehicle:draw()
end

function HoseSystemFillArmVehicle:checkPlaneY(y, trans)
    local index = self.fillArmFillVolumeIndex

    if self.fillVolumes ~= nil and self.fillVolumes[index].volume ~= nil then
        local plane = self.fillVolumes[index].volume

        local planeLocal = { worldToLocal(plane, trans[1], y, trans[3]) }
        local height = getFillPlaneHeightAtLocalPos(plane, planeLocal[1], planeLocal[3])
        local planeWorld = { localToWorld(plane, planeLocal[1], height, planeLocal[3]) }

        planeWorld[2] = planeWorld[2] + self.fillArmOffset

        return planeWorld[2] >= y, planeWorld[2]
    end

    return false, 0
end